package routing;

import core.DTNHost;
import core.Settings;
import routing.util.*;

import java.util.List;

public class BasicEnergyHomeRouter extends BasicEnergyRouter implements
        EnergySupplier, PriceRouter {

    private EnergyOasis energyOasis = new EnergyOasis();

    public BasicEnergyHomeRouter(Settings s) {
        super(s);
        this.state = State.SUPPLY;
    }
    public BasicEnergyHomeRouter(BasicEnergyHomeRouter prototype) {
        super(prototype);
        this.state = prototype.state;
    }

    @Override
    public MessageRouter replicate() {
        BasicEnergyHomeRouter prototype = this;
        return new BasicEnergyHomeRouter(prototype);
    }

    @Override
    public int getNodesChargingCount() {
        int size = this.seekers.size();
        if (size > this.plugCount) {
            return this.plugCount;
        }
        return size;
    }

    @Override
    public List<DTNHost> getQueueHead() {
        return null;
    }

    @Override
    public boolean isSupplying() {
        return true;
    }

    @Override
    public int getPlugCount() {
        return this.plugCount;
    }

    @Override
    public EnergyModule getEnergyModule() {
        return this.energyOasis;
    }

    @Override
    protected void chargePeer(EnergySeeker seeker, double interval) {
        seeker.getEnergyModule().charge(VehicleBattery.CHARGE_SLOW, interval);
    }

    @Override
    public int getNodesQueuingCount() {
        int size = this.seekers.size() - this.plugCount;
        if (size >= 0) {
            return size;
        } else {
            return 0;
        }
    }
}
