package routing;

import core.DTNHost;
import core.Settings;
import routing.util.*;

import java.util.List;

public class BasicEnergyStationRouter extends BasicEnergyRouter implements
        EnergySupplier, PriceRouter {

    private EnergyOasis energyOasis = new EnergyOasis();
    public BasicEnergyStationRouter(Settings s) {
        super(s);
        this.state = State.SUPPLY;
    }
    public BasicEnergyStationRouter(BasicEnergyStationRouter prototype) {
        super(prototype);
        this.state = prototype.state;
    }
    public MessageRouter replicate() {
        BasicEnergyStationRouter prototype = this;
        return new BasicEnergyStationRouter(prototype);
    }
    public int getNodesChargingCount() {
        int size = this.seekers.size();
        if (size > this.plugCount) {
            return this.plugCount;
        }
        return size;
    }
    public List<DTNHost> getQueueHead() {
        return null;
    }
    public boolean isSupplying() {
        return true;
    }
    public int getPlugCount() {
        return this.plugCount;
    }
    public EnergyModule getEnergyModule() {
        return this.energyOasis;
    }
    protected void chargePeer(EnergySeeker seeker, double interval) {
        seeker.getEnergyModule().charge(VehicleBattery.CHARGE_FAST, interval);
    }
    public int getNodesQueuingCount() {
        int size = this.seekers.size() - this.plugCount;
        if (size >= 0) {
            return size;
        } else {
            return 0;
        }
    }
}
