#!/usr/bin/env python3

"Generate a Manhatten grid in WKT format for ONE."

__author__ = "Adam Walker"
__email__ = "Adam.Walker4@nottingham.ac.uk"

from itertools import repeat
import sys

USAGE = f"{sys.argv[0]} MAX_X_M MAX_Y_M INTERVAL_M OUTFILE"

if len(sys.argv) != 5:
    print(USAGE)
    exit(1)
else:
    max_x, max_y, interval = map(int, sys.argv[1:4])
    max_x += 1
    max_y += 1
    output = sys.argv[4]


with open(output, "w") as f:
    for x in range(0, max_x, interval):
        points = list(zip(repeat(x), range(0, max_x, interval)))
        streets1 = ', '.join(f"{x} {y}" for x, y in points)
        streets2 = ', '.join(f"{y} {x}" for x, y in points)
        print(f"LINESTRING ({streets1})", file=f)
        print(f"LINESTRING ({streets2})", file=f)
